import type { AuthObject } from '@clerk/backend';
import type { PendingSessionOptions } from '@clerk/types';
import type { LoggerNoCommit } from '../../utils/debugLogger';
import type { RequestLike } from '../types';
/**
 * Given a request object, builds an auth object from the request data. Used in server-side environments to get access
 * to auth data for a given request.
 */
export declare function getAuthDataFromRequest(req: RequestLike, { treatPendingAsSignedOut, ...opts }?: {
    secretKey?: string;
    logger?: LoggerNoCommit;
} & PendingSessionOptions): AuthObject;
//# sourceMappingURL=getAuthDataFromRequest.d.ts.map